# **Post-Test Survey (Usability & Experience Feedback)**  

*Objective: Gather user feedback on the usability, effectiveness, and clarity of the extension during the testing session.*  

---

## **Usability & Functionality**  

1. **While using the extension to detect and refactor code smells, I felt...**  
   *Mark only one oval per row.*  

   |                                                           | 1 (Strongly Disagree) | 2 (Disagree) | 3 (Neutral) | 4 (Agree) | 5 (Strongly Agree) |
   | --------------------------------------------------------- | --------------------- | ------------ | ----------- | --------- | ------------------ |
   | **Confident in my ability to use the tool effectively**   | ○                     | ○            | ○           | ○         | ○                  |
   | **Confused about how to use certain features**            | ○                     | ○            | ○           | ○         | ○                  |
   | **Guided towards a good solution by the extension**       | ○                     | ○            | ○           | ○         | ○                  |
   | **Productive in completing the refactoring tasks**        | ○                     | ○            | ○           | ○         | ○                  |
   | **Slowed down by the extension’s interface or processes** | ○                     | ○            | ○           | ○         | ○                  |

---

## **User Interface (UI) Experience**  

2. **When interacting with the extension’s user interface, I felt...**  
   *Mark only one oval per row.*  

   |                                                       | 1 (Strongly Disagree) | 2 (Disagree) | 3 (Neutral) | 4 (Agree) | 5 (Strongly Agree) |
   | ----------------------------------------------------- | --------------------- | ------------ | ----------- | --------- | ------------------ |
   | **Satisfied with the overall design and layout**      | ○                     | ○            | ○           | ○         | ○                  |
   | **Frustrated by unclear or cluttered elements**       | ○                     | ○            | ○           | ○         | ○                  |
   | **Impressed by the visual appeal of the interface**   | ○                     | ○            | ○           | ○         | ○                  |
   | **Confused by the placement of buttons or menus**     | ○                     | ○            | ○           | ○         | ○                  |
   | **Delighted by the ease of navigating the interface** | ○                     | ○            | ○           | ○         | ○                  |
   | **Annoyed by the lack of intuitive controls**         | ○                     | ○            | ○           | ○         | ○                  |

---

## **Performance & Reliability**  

3. **When evaluating the extension’s performance during testing, I felt...**  
   *Mark only one oval per row.*  

   |                                                        | 1 (Strongly Disagree) | 2 (Disagree) | 3 (Neutral) | 4 (Agree) | 5 (Strongly Agree) |
   | ------------------------------------------------------ | --------------------- | ------------ | ----------- | --------- | ------------------ |
   | **Confident that the extension worked reliably**       | ○                     | ○            | ○           | ○         | ○                  |
   | **Assured that the code smell detection was accurate** | ○                     | ○            | ○           | ○         | ○                  |
   | **Frustrated by technical issues or bugs**             | ○                     | ○            | ○           | ○         | ○                  |
   | **Trusting of the refactoring suggestions provided**   | ○                     | ○            | ○           | ○         | ○                  |

---

## **Learning Curve & Guidance**  

4. **When learning how to use the extension during testing, I felt...**  
   *Mark only one oval per row.*  

   |                                                                    | 1 (Strongly Disagree) | 2 (Disagree) | 3 (Neutral) | 4 (Agree) | 5 (Strongly Agree) |
   | ------------------------------------------------------------------ | --------------------- | ------------ | ----------- | --------- | ------------------ |
   | **Supported by clear and sufficient instructions**                 | ○                     | ○            | ○           | ○         | ○                  |
   | **Overwhelmed by the complexity of the tool**                      | ○                     | ○            | ○           | ○         | ○                  |
   | **Curious to learn more through additional examples or tutorials** | ○                     | ○            | ○           | ○         | ○                  |

---

## **Perceived Value & Utility**  

5. **When considering the extension’s potential impact, I felt...**  
   *Mark only one oval per row.*  

   |                                                                           | 1 (Strongly Disagree) | 2 (Disagree) | 3 (Neutral) | 4 (Agree) | 5 (Strongly Agree) |
   | ------------------------------------------------------------------------- | --------------------- | ------------ | ----------- | --------- | ------------------ |
   | **Optimistic that the extension could improve energy efficiency in code** | ○                     | ○            | ○           | ○         | ○                  |
   | **Encouraged that the extension could help me write better code**         | ○                     | ○            | ○           | ○         | ○                  |
   | **Informed by the energy savings information provided**                   | ○                     | ○            | ○           | ○         | ○                  |
   | **Interested in using this extension in the future**                      | ○                     | ○            | ○           | ○         | ○                  |

---

## **Emotional & Cognitive Experience**  

6. **When reflecting on my overall experience with the extension, I felt...**  
   *Mark only one oval per row.*  

   |                                                      | 1 (Strongly Disagree) | 2 (Disagree) | 3 (Neutral) | 4 (Agree) | 5 (Strongly Agree) |
   | ---------------------------------------------------- | --------------------- | ------------ | ----------- | --------- | ------------------ |
   | **Motivated to continue using the extension**        | ○                     | ○            | ○           | ○         | ○                  |
   | **Frustrated by unnecessary complexity in the tool** | ○                     | ○            | ○           | ○         | ○                  |
   | **Satisfied with the overall experience**            | ○                     | ○            | ○           | ○         | ○                  |

---

## **Open-Ended Feedback**  

7. **What was the most frustrating part of using the extension during testing?**  
    ___________________________________________________________  

8. **What did you find most useful about the extension during testing?**  
    ___________________________________________________________  

9. **Do you have any suggestions for improving the extension’s user interface?**  
    ___________________________________________________________  

10. **Any other comments or feedback about your testing experience with the extension?**  
    ___________________________________________________________  
