# Task Instructions

## Mock Installation Documentation
The extension can be installed to detect energy inefficiencies (smells) in you code and refactor them.

### Commands
Open the vscode command palette (`CTRL+SHFT+P`)

**Detect smells:** `Eco: Detect Smells`

**Refactor smells** `Eco: Refactor Smell` or `CTRL+SHFT+R` or (*to be discovered*)

## Tasks

Report your observations **aloud**!

### Task 1: Smells Detection

1. Open the `sample.py` file.
2. Detect the smells in the file.
3. What do you see?

### Task 2: Line Selection

1. In the same `sample.py` file, select one of the highlighted lines.
2. What do you see?
3. Select another line.

### Task 3: Hover

1. In the same file, now hover over a highlighted line.
2. What do you see?

### Task 4: Initiate Refactoring (single)

1. In the same file, refactor any smell of your choice.
2. What do you observe immediately after?
3. Does a sidebar popup after some time?

### Task 5: Refactor Smell (sidebar)

1. What information do you see in the sidebar?
2. Do you understand the information communicated?
3. Do you see what was changed in the file?
4. Try rejecting a smell, did the file change?
5. Do tasks 1, 4 and 5 again but reject a smell, did the file stay the same?

*Moderator change workspace*

### Task 6: Refactor Multi-File Smell

1. Open the `main.py` file.
2. Detect the smells in the file.
3. Refactor any smell of your choice.
4. Do you see anything different in the sidebar?
5. Try clicking on the new addition to the sidebar, notice anything?
6. Try accepting the refactoring, did both files change?

*Moderator change workspace*

### Task 7: Change Smell Settings

1. Open the `sample.py` file.
2. Detect the smells in the file.
3. Take note of the smells detected.
4. Open the settings page (`CTRL+,`)
5. Navigate to the **extensions** drop-down and select Eco Optimizer.
6. Unselect one of the smells you noticed earlier.
7. Navigate back to the `sample.py` file.
8. Detect the smells again, is the smell you unselected still there?