# POC Checklist

**Created by**: Spencer Smith

---
### Project Status/scope
  - [ ] Team has a name (If the name is still TBD, create a name and issue a
  pull request in the course repo).
  - [ ] Risks for POC demo are up to date in Problem Statement document (any
  feedback from the TA has been addressed).
  - [ ] Planned POC demo is up to date in Problem Statement document (any
  feedback from the TA has been addressed).
  - [ ] Have a clear plan on which team members will show which parts of the POC demo.
  - [ ] Know which devices or devices will be used for the demo.
  - [ ] The team has practiced the demo.
  - [ ] Demo will include a live demonstration of running code.
  - [ ] If the planned demo will be unsuccessful, the team has some ideas on how
  to fix the problem, or redefine the scope of the project.

### Team Status
  - [ ] GitHub contributions page shows all team members with similar number of
  commits, lines added, lines deleted.  When there is a difference, you should
  determine if there is a team cooperation problem, or simply a GitHub book
  keeping explanation.
  - [ ] If your team has been coauthoring work, but not using co-author commits
  in GitHub, you plan on doing so going forward.
  - [ ] Team has thought about how work will be divided between team members
  going forward.  Revisit development plan if there are any changes.

### Issue Tracker
  - [ ] Some of the issues created by other teams for the previous deliverables
  have been closed.
  - [ ] All closed issues include an explanation of why the issue was closed.
  The explanation could be the issue was closed because of an accepted pull
  request, or traceability to the specific commit hash that closed the issue.
  - [ ] Issues aren't too big.  They are doable by a single person with a
  reasonable amount of time.  What needs to happen for the issues to be closed
  is clear.
  - [ ] There are examples of issues created by the team have been closed.
  - [ ] Issues created for team meetings (labelled so easy to find).
  - [ ] Issues created for lectures (labelled so easy to find).
  - [ ] Issues created for meetings with supervisor (labelled so easy to find).

### CI/CD
  - [ ] Planning for CI/CD has started.

### Repo
  - [ ] README file on landing page has content
  - [ ] Branches are used as appropriate